﻿# fuelle.py
# Programm zum Füllen eines Containers mit Tiefensuche
# (Rucksackproblem)
# Im Vergleich mit der entsprechenden Lösung mit Scheme
# ist wichtig, dass Python ebenfalls Rückgabewerte in
# Bedingungen akzeptiert, die nicht True oder False sind.
# Weierhin ist wichtig, dass bei den rekursiven Aufrufen
# die Variablen neu angelegt werden und so nicht die Werte
# der aufrufenden Rekursionsstufe verändert werden.


# Globale Variable für die Stücke:
stuecke=[30,30,30,20,20,20]
container=[]

# Prädikat zum Testen, ob der Container voll ist.
def istVoll(container, fassungsvermoegen):
    return fassungsvermoegen==sum(container)

def istZuVoll(container, fassungsvermoegen):
    return fassungsvermoegen<sum(container)


def fuelle(stuecke, container, fassungsvermoegen):
    if istVoll(container, fassungsvermoegen):
        return container
    elif len(stuecke)==0:
        return False
    elif istZuVoll(container, fassungsvermoegen):
        return False
    else:
        ergebnis=fuelle(stuecke[1:], container+stuecke[:1], fassungsvermoegen)
        if ergebnis:
            return ergebnis
        else:
            return fuelle(stuecke[1:], container, fassungsvermoegen)
    
print( fuelle(stuecke, container, 90) )
print( fuelle(stuecke, container, 100) )
